# db/migrate/20240612000000_add_local_top_algorithm_support.rb
class AddLocalTopAlgorithmSupport < ActiveRecord::Migration[8.0]
  disable_ddl_transaction! # Allows concurrent operations

  def change
    # 1. Add reference without immediate foreign key validation
    add_reference :statuses, :status_stat, 
      index: { algorithm: :concurrently }, # Concurrent index
      foreign_key: { on_delete: :cascade, validate: false } # Defer validation

    # 2. Add user preference column (safe operation)
    add_column :users, :feed_algorithm, :string, default: 'chronological'
  end
end